Attribute VB_Name = "basSol"
Option Explicit



'DEKLARATIONEN
'------------------------------------------------------------
Private Declare Function GetDC Lib "user32" (ByVal hWnd _
        As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" _
        (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
        ByVal nWidth As Long, ByVal nHeight As Long, _
        ByVal hSrcDC As Long, ByVal xSrc As Long, _
        ByVal ySrc As Long, ByVal nSrcWidth As Long, _
        ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
        
Private Declare Function SetStretchBltMode Lib "gdi32" _
        (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd _
        As Long, ByVal hdc As Long) As Long
        
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As _
        Long, ByVal x As Long, ByVal y As Long, ByVal nWidth _
        As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
        ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop _
        As Long) As Long

Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long

Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long



'DATENTYPEN
'------------------------------------------------------------
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type



' KONSTANTEN
'------------------------------------------------------------
Private Const SRCCOPY = &HCC0020

Private Const KEY0 = "wbbbbbbbbww"
Private Const KEY1 = "wbwwwwwwwwb"
Private Const KEY2 = "wbbwwwwbbbw"
Private Const KEY3 = "wbwwwwwwbwb"
Private Const KEY4 = "wwwwwwbbwwb"
Private Const KEY5 = "bbbbbbwwbwb"
Private Const KEY6 = "wbbbbbbbbwb"
Private Const KEY7 = "bwwwwwwwwwb"
Private Const KEY8 = "wbbbwbbbbwb"
Private Const KEY9 = "wbbbbwwwbww"

Private Const WindowsTitle = "Solitr"
Private Const ProgramTitle = "Solitr"
Private Const ClassName = "Stat"

Private Const StatusHeight = 17
Private Const StatusWidth = 160

Private Const YOffset = 0
Private Const XSpace1 = 8
Private Const LetterWidth = 8



'------------------------------------------------------------
'HAUPTFUNKTION: SolPunkte
'
'Argumente: Punkte (Rckgabe der Punkte)
'           Zeit (Rckgabe der Zeit)
'           Bild (eine beliebige PictureBox zum Zwischenspeichern)
'           hWnd (Fensterhandle des Fenster, bei keiner Angabe
'                 wird er automatisch ermittelt)
'
'Die Funktion kopiert die Grafik der Statusbar in die Picturebox,
'und durchsucht dann die Spalten nach Vorkommen eines Doppelpunktes,
'hinter dem in 8 Pixel Entfernung die erste Zahl beginnt. Die Zahlen
'sind immer 8 Pixel breit; von jeder Zahl wird die erste Reihe der Pixel
'+ einer in der Mitte (fr 0 und 6) als String gespeichert. Anhand der ersten
'Spalte kann man alle Zahlen (bis auf 0 und 6) eindeutig identifizieren.
'
'Version mit zustzliche Funktionen
'------------------------------------------------------------

Public Sub SolPunkte(Punkte As Long, Zeit As Long, Bild As PictureBox, Optional ByVal hWnd As Long = 0)
    Dim shWnd As Long                     'Statusbar-hWnd
    Dim si1 As Long, si2 As Long          'Positionsindex
    Dim str1 As String, str2 As String    'Zwischenspeicher fr Pixel
    Dim a As Integer                      'Schleifenzhler
    Dim Result1  As Long, Result2 As Long 'Ergebnisvariablen
    
    On Error GoTo ErrSub
    
    
    'BILDEXTRAKTION
    
    'Herausfinden/bernehmen des Fensterhandles
    shWnd = hWnd
    If shWnd = 0 Then shWnd = FindWindowEx(FindWindow(vbNullString, WindowsTitle), 0&, ClassName, vbNullString)
    
    'Grafik kopieren
    CopyImage shWnd, Bild
    
    
    'ZEICHENERKENNUNG
    
    'Suche nach Anfang der ersten Zahl (hinter Doppelpunkt)
    si1 = SearchPos(0, 160, Bild)
    'Erste Zahl extrahieren
    str1 = ExtractNumber(si1, Bild)
    
    'Suche nach nchster Zahl
    si2 = SearchPos(si1, 160, Bild)
    'Zweite Zahl extrahieren
    str2 = ExtractNumber(si2, Bild)
    
    'Zuordnen der erkannten Zahlen
    Result1 = GetResults(str1)
    Result2 = GetResults(str2)
    
    'Zuweisen der Ergebnisse
    Punkte = Result1
    Zeit = Result2
    
    'Lschen des Bildfeldes
    Bild.Cls
    
    Exit Sub
ErrSub:
    MsgBox "Fehler!", vbCritical, "Solitr"  'Solitr nicht gestartet?
    Exit Sub
End Sub

'Kopiert die Statusgrafik in das Bildfeld
Private Sub CopyImage(shWnd As Long, Bild As PictureBox)
    Dim r As RECT                         'Statusbarkoordinaten
    Dim ZhDC As Long, ShDC As Long        'Zeichenhandles
    
    'Zeichenhandles holen
    ZhDC = Bild.hdc
    ShDC = GetDC(shWnd)
    'Fensterkoordinaten holen
    GetWindowRect shWnd, r
    'Solitrfenster anzeigen (ntig, da sonst ein Kopieren nicht mglich ist)
    AppActivate ProgramTitle
    'Bild in PictureBox kopieren
    Bild.AutoRedraw = False
    BitBlt ZhDC, 0, 0, StatusWidth, _
                  StatusHeight, ShDC, _
                  r.Right - r.Left - StatusWidth, 0, SRCCOPY
    Bild.Refresh
    Bild.AutoRedraw = True
    'Wieder eigene Anwendung anzeigen
    AppActivate App.Title
End Sub

'Sucht nach dem Vorkommen eines Doppelpunktes
Private Function SearchPos(Start As Long, Ende As Long, Bild As PictureBox) As Long
    Dim a As Long
    
    For a = Start To Ende
        DoEvents
        If Bild.Point(a, 5 + YOffset) < 100 Then
            If Bild.Point(a, 12 + YOffset) < 100 Then
                If Bild.Point(a, 8 + YOffset) > 15000000 And Bild.Point(a, 9 + YOffset) > 15000000 And Bild.Point(a, 5 + YOffset) = Bild.Point(a, 6 + YOffset) And Bild.Point(a, 11 + YOffset) = Bild.Point(a, 12 + YOffset) Then
                    SearchPos = a + XSpace1
                    Exit Function
                End If
            End If
        End If
    Next
End Function

'Extrahiert alle gefundenen Zahlen
Private Function ExtractNumber(si1 As Long, Bild As PictureBox) As String
    Dim Result As String, a As Long
    
    Do
        If si1 + LetterWidth > 160 Then Exit Do 'Wenn am Ende der Zeile dann abbrechen
        For a = 3 To 12  'Y-Pixel 3-12
            Result = Result & IIf(Bild.Point(si1, a + YOffset) > 15000000, "w", "b")
            DoEvents
        Next
        '+ Einer in der Mitte zur Erkennung von Null/Sechs
        Result = Result & IIf(Bild.Point(si1 + 2, 7 + YOffset) > 15000000, "w", "b")
        If Right(Result, 11) = String(11, "w") Then si1 = si1 + 3: Exit Do
        si1 = si1 + LetterWidth 'Nchster Buchstabe hat immer den Abstand von 8 Pixeln
        DoEvents
    Loop
    
    ExtractNumber = Result
End Function

'Ordnet den erkannten Pixelspalten Zahlen zu
Private Function GetResults(str1 As String) As Long
    Dim Result As Long, a As Long
    For a = 1 To Len(str1) Step 11
        Select Case Mid(str1, a, 11)
        Case KEY0: Result = Result & "0"
        Case KEY1: Result = Result & "1"
        Case KEY2: Result = Result & "2"
        Case KEY3: Result = Result & "3"
        Case KEY4: Result = Result & "4"
        Case KEY5: Result = Result & "5"
        Case KEY6: Result = Result & "6"
        Case KEY7: Result = Result & "7"
        Case KEY8: Result = Result & "8"
        Case KEY9: Result = Result & "9"
        End Select
    Next
    GetResults = Result
End Function
