Attribute VB_Name = "basgetsolitr"
Option Explicit

'Viele, viele Typen, Konstanten und Funktionen
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Public Type typeSolitr
    Top As Single
    Left As Single
    Height As Single
    Width As Single
    hwnd As Long
End Type

Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal wIndx As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetWindowDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

Private Const GW_HWNDFIRST = 0
Private Const GW_HWNDLAST = 1
Private Const GW_HWNDNEXT = 2
Private Const GW_HWNDPREV = 3
Private Const GW_OWNER = 4
Private Const GW_CHILD = 5
Private Const GW_MAX = 5
Private Const GWL_STYLE = (-16)
Private Const WS_VISIBLE = &H10000000
Private Const WS_BORDER = &H800000
Public Const StatusHeight = 16 'Gibt die Hhe der Statusleiste zurck (Standard=16 Pixel)
Public Const BottomBorderHeight = 4 'Gibt die Hhe des unteren Borders des Solitrspiels zurck
Public Const RightBorderWidth = 4 'Gibt die Breite des rechten Borders des Solitrspiels zurck
Public Const TopFree = 2 'Gibt zurck, wie viele Pixel oberhalb der Schrift noch frei sind
Public Const RightFree = 4 'Gibt zurck, wie viele Pixel rechts von der Schrift noch frei sind
Public Const Zeit_Len = 34 'Lnge des "Zeit:"-Strings und der 6 leeren Pixel

Dim SOL As typeSolitr 'der Speicher-Solitrtyp

Public Function GetSolitrInfo(frm As Variant) As typeSolitr
Dim hwnd As Long
Dim sTitle As String
Dim RCT As RECT

'Erstes Windowhandle
hwnd = GetWindow(frm.hwnd, GW_HWNDFIRST)
  
Do 'Durchluft alle Fenster um hWnd des Spiels herauszufinden
  'Fenstertitel des aktuellen Windows
  sTitle = GetWindowTitle(hwnd)
  
  'Wenn Solitr...
  If sTitle = "Solitr" Then
  'Informationen geben/holen
  GetWindowRect hwnd, RCT
  GetSolitrInfo.Top = RCT.Top
  GetSolitrInfo.Left = RCT.Left
  GetSolitrInfo.Width = RCT.Right - RCT.Left
  GetSolitrInfo.Height = RCT.Bottom - RCT.Top
  GetSolitrInfo.hwnd = hwnd
  SOL = GetSolitrInfo 'Abspeichern fr spter
  Exit Do
  End If
  
  'ansonsten nchses Handle
  hwnd = GetWindow(hwnd, GW_HWNDNEXT)
Loop Until hwnd = 0
End Function

Private Function GetWindowTitle(ByVal hwnd As Long) As String
Dim lResult As Long
Dim sTemp As String

lResult = GetWindowTextLength(hwnd) + 1
sTemp = Space(lResult)
lResult = GetWindowText(hwnd, sTemp, lResult)
'Gibt Fenstertitel des angegebenen Windows (hWnd) zurck
GetWindowTitle = Left(sTemp, Len(sTemp) - 1)
End Function

Public Sub StatusScreenShot(hdc As Long)
'Macht einen Screenshot der Statusleiste (weier Bereich) des Solitrspiels
'und gibt ihn in einer Picturebox aus

With SOL
    Dim dx&
    Dim dy&
    Dim screenDC&, compDC&
    Dim screenbitmap&
    Dim hbm&, h&
    
    dx = Screen.Width / Screen.TwipsPerPixelX
    dy = Screen.Height / Screen.TwipsPerPixelY
    screenDC = GetWindowDC(.hwnd)
    compDC = CreateCompatibleDC(screenDC)
    hbm = CreateCompatibleBitmap(screenDC, dx, dy)
    h = SelectObject(compDC, hbm)
    BitBlt compDC, 0, 0, dx, dy, screenDC, 0, 0, vbSrcCopy
    BitBlt hdc, RightBorderWidth + RightFree - 1, 0, dx, StatusHeight, compDC, 0, .Height - StatusHeight - BottomBorderHeight, vbSrcCopy
    DeleteObject SelectObject(compDC, h)
    DeleteDC compDC
    ReleaseDC .hwnd, screenDC
End With
End Sub

Public Sub ReadTimePoints(PicBox As Variant, TimeInput As TextBox, PointsInput As TextBox)
Dim sw&, sh&
Dim lNum As Long
Dim lTime As String
Dim lPoint As String
Dim haveTime As Boolean
Dim havePoints As Boolean
Dim i
'INFO: Jede Ziffer hat irgendwo Pixel oder keine, die eine Identifizierung einfach machen
With PicBox
.ScaleMode = 3 'Pixel
sw = .ScaleWidth - 1
sh = .ScaleHeight - 1
lTime = 0
lPoint = 0
haveTime = False
havePoints = False

nextRound:
Do 'Durchluft Pixel der Statusleiste und gibt so Zeit und Punkte zurck
DoEvents
    If GetPixel(.hdc, sw - 6, TopFree) = vbBlack Then 'Entweder 5 oder 7
        If GetPixel(.hdc, sw - 1, TopFree + 1) = vbBlack Then
        lNum = 7
        Else
        lNum = 5
        End If
    ElseIf GetPixel(.hdc, sw - 4, TopFree + 1) <> vbBlack And _
           GetPixel(.hdc, sw - 3, TopFree + 1) <> vbBlack And _
           GetPixel(.hdc, sw - 4, TopFree + 4) <> vbBlack And _
           GetPixel(.hdc, sw - 3, TopFree + 4) <> vbBlack Then
        lNum = 0
    ElseIf GetPixel(.hdc, sw - 4, TopFree + 1) = vbBlack And _
           GetPixel(.hdc, sw - 3, TopFree + 1) = vbBlack And _
           GetPixel(.hdc, sw - 4, TopFree + 5) = vbBlack And _
           GetPixel(.hdc, sw - 3, TopFree + 5) = vbBlack Then
        lNum = 1
    ElseIf GetPixel(.hdc, sw - 4, TopFree) <> vbBlack Then
        lNum = 4
    ElseIf GetPixel(.hdc, sw - 5, TopFree + 7) = vbBlack And _
           GetPixel(.hdc, sw - 6, TopFree + 7) = vbBlack And _
           GetPixel(.hdc, sw - 5, TopFree + 8) = vbBlack And _
           GetPixel(.hdc, sw - 6, TopFree + 8) = vbBlack Then
        lNum = 2
    ElseIf GetPixel(.hdc, sw - 1, TopFree + 4) = vbBlack Then
        lNum = 9
    ElseIf GetPixel(.hdc, sw - 4, TopFree + 4) = vbBlack And _
           GetPixel(.hdc, sw - 3, TopFree + 4) = vbBlack Then '3, 6 oder 8
                If GetPixel(.hdc, sw - 6, TopFree + 4) = vbBlack And _
                   GetPixel(.hdc, sw - 5, TopFree + 4) = vbBlack Then
                  lNum = 6
                ElseIf GetPixel(.hdc, sw - 6, TopFree + 4) <> vbBlack And _
                   GetPixel(.hdc, sw - 5, TopFree + 4) <> vbBlack Then
                  lNum = 3
                ElseIf GetPixel(.hdc, sw - 6, TopFree + 4) <> vbBlack And _
                   GetPixel(.hdc, sw - 5, TopFree + 4) = vbBlack Then
                  lNum = 8
                End If
    Else
    'Sollte die Identifizierung nicht mglich sein,
    'so ist anscheinend die Schriftart nicht korrekt
    End If
DoEvents
If haveTime = False Then
lTime = lNum & lTime
Else
lPoint = lNum & lPoint
End If
sw = sw - 7
Loop Until GetPixel(.hdc, sw - 6, TopFree + 2) <> vbBlack And _
           GetPixel(.hdc, sw - 5, TopFree + 2) <> vbBlack And _
           GetPixel(.hdc, sw - 4, TopFree + 2) <> vbBlack And _
           GetPixel(.hdc, sw - 3, TopFree + 2) <> vbBlack And _
           GetPixel(.hdc, sw - 2, TopFree + 2) <> vbBlack And _
           GetPixel(.hdc, sw - 1, TopFree + 2) <> vbBlack

If haveTime = False Then 'Wenn die Zeit schon gemessen wurde, aber Punkte noch nicht, dann...
haveTime = True
sw = sw - Zeit_Len
GoTo nextRound
End If

TimeInput.Text = CLng(Left(lTime, Len(lTime) - 1))
PointsInput.Text = CLng(Left(lPoint, Len(lPoint) - 1))
End With
End Sub
