Attribute VB_Name = "modPicToText"
Option Explicit

Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

Public Function getTextFromPicture(srcPicture As PictureBox, chrPicture As PictureBox) As String
   Dim i As Long
   Dim curLetterWidth As Long
   Dim srcLetterStart As Long
   Dim curX As Long
   Dim FoundLetter As Boolean
      
   'Diese Schriftart soll konvertiert werden'
   chrPicture.FontName = "System"
   chrPicture.FontSize = 10
   chrPicture.FontBold = True

   curX = 0
   getTextFromPicture = ""

   Do

      FoundLetter = False
      srcLetterStart = getLetterStart(srcPicture, curX)

      If srcLetterStart >= srcPicture.ScaleWidth Or srcLetterStart = 0 Then Exit Do
   
      'Jede Zahl durchprobieren'
      For i = 0 To 9
   
         chrPicture.Cls
         chrPicture.CurrentX = 0
         chrPicture.CurrentY = 0
         chrPicture.Print CStr(i)
   
         curLetterWidth = getLetterEnd(chrPicture, 1)
   
         If CheckPictures(chrPicture, 1, curLetterWidth, srcPicture, srcLetterStart) = True Then
            FoundLetter = True
            getTextFromPicture = getTextFromPicture & CStr(i)
            Exit For
         End If
   
      Next i

      'Wenn keine Zahl erkannt wurde mit Stern auffllen'
      If FoundLetter = False Then
         getTextFromPicture = getTextFromPicture & "*"
      End If

      curX = srcLetterStart + 1 + curLetterWidth

   Loop Until srcLetterStart = 0

End Function

Private Function CheckPictures(chrPicture As PictureBox, X1 As Long, LetterWidth As Long, srcPicture As PictureBox, X2 As Long) As Boolean
   Dim X As Long, Y As Long
   Dim chrPixel As Long, srcPixel As Long

   CheckPictures = True

   'Zwei Zeichen vergleichen (exakt)'
   For X = 0 To LetterWidth
      For Y = 0 To srcPicture.ScaleHeight - 1
         chrPixel = GetPixel(chrPicture.hdc, X1 + X, Y + 1)
         srcPixel = GetPixel(srcPicture.hdc, X2 + X, Y)
         If chrPixel <> srcPixel Then
            CheckPictures = False
            Exit Function
         End If
      Next Y
   Next X

End Function

Private Function getLetterEnd(chrPicture As PictureBox, StartPos As Long) As Long
   Dim X As Long, Y As Long
   Dim FoundPixel As Boolean
   Dim colPixel As Long
   
   'Vertikale Zeile suchen, in der kein Teil eines Buchstaben mehr ist'
   For X = StartPos To chrPicture.ScaleWidth
      FoundPixel = False
      For Y = 0 To chrPicture.ScaleHeight - 1
         colPixel = GetPixel(chrPicture.hdc, X, Y)
         If colPixel <> chrPicture.BackColor Then
            FoundPixel = True
            Exit For
         End If
      Next Y
      If FoundPixel = False Then
         getLetterEnd = X - 1 - StartPos
         Exit For
      End If
   Next X

End Function

Private Function getLetterStart(chrPicture As PictureBox, StartPos As Long) As Long
   Dim X As Long, Y As Long
   Dim FoundPixel As Boolean
   Dim colPixel As Long
   
   'Vertikale Zeile suchen, in der der erste Teil eines Buchstaben ist'
   For X = StartPos To chrPicture.ScaleWidth
      FoundPixel = False
      For Y = 0 To chrPicture.ScaleHeight - 1
         colPixel = GetPixel(chrPicture.hdc, X, Y)
         If colPixel = 0 Then
            FoundPixel = True
            Exit For
         End If
      Next Y
      If FoundPixel = True Then
         getLetterStart = X
         Exit For
      End If
   Next X

End Function

