Attribute VB_Name = "modSolitaireReader"
''''''''''''''''''''''''''''
'' Solitaire Reader Modul ''
''''''''''''''''''''''''''''
' Geschrieben von Pablo Hoch (mel@melaxis.com) fr ActiveVB.de
' Getestet unter Windows XP Professional Deutsch und Windows 2000 Professional Deutsch
' 24/05/2003

Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32.dll" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Private Declare Function OpenProcess Lib "kernel32.dll" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
Private Declare Function ReadProcessMemory Lib "kernel32.dll" (ByVal hProcess As Long, lpBaseAddress As Any, lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long

Private Const PROCESS_VM_READ As Long = (&H10)

Private hWnd As Long

' Diese Funktion gibt die aktuelle Punktzahl zurck.
Public Function GetSolitaireScore() As Long

    Dim pid As Long
    Dim hProcess As Long
    Dim score As Long
    Dim addr As Long

    If hWnd = 0 Then
        ' Wir haben das Solitrfenster noch nicht gefunden.
        ' Suchen wir es...
        Call FindSolitaire
        If hWnd = 0 Then
            ' Solitr lauft nicht. 0 zurckgeben.
            GetSolitaireScore = 0
            Exit Function
        End If
    End If
    
    ' Wenn wir bis hier kommen, haben wir das Solitrfenster gefunden.
    ' Jetzt brauchen wir noch die Prozess-ID (PID).
    Call GetWindowThreadProcessId(hWnd, pid)
    
    hProcess = OpenProcess(PROCESS_VM_READ, False, pid)
    If hProcess = 0 Then
        ' Wir knnen nicht auf den Prozess zugreifen. Evtl. luft er nicht mehr oder wir haben keine Rechte.
        ' Fensterhandle zurcksetzen und 0 zurckgeben.
        hWnd = 0
        GetSolitaireScore = 0
        Exit Function
    End If
    
    ' Adresse des virtuellen Speichers besorgen (Solitr verwendet DMA)
    Call ReadProcessMemory(hProcess, ByVal &H1007170, addr, 4, 0&)
    
    ' Offset des Punktestands addieren (Ergebnis ist die korrekte Adresse)
    addr = addr + &H30
    
    ' Punktestand aus dem Speicher lesen
    Call ReadProcessMemory(hProcess, ByVal addr, score, 4, 0&)
    
    ' Prozesshandle freigeben.
    Call CloseHandle(hProcess)
    
    GetSolitaireScore = score

End Function

' Diese Funktion gibt die aktuelle Zeit (in Sekunden) zurck.
Public Function GetSolitaireTime() As Long

    Dim pid As Long
    Dim hProcess As Long
    Dim time As Long
    Dim addr As Long

    If hWnd = 0 Then
        ' Wir haben das Solitrfenster noch nicht gefunden.
        ' Suchen wir es...
        Call FindSolitaire
        If hWnd = 0 Then
            ' Solitr lauft nicht. 0 zurckgeben.
            GetSolitaireTime = 0
            Exit Function
        End If
    End If
    
    ' Wenn wir bis hier kommen, haben wir das Solitrfenster gefunden.
    ' Jetzt brauchen wir noch die Prozess-ID (PID).
    Call GetWindowThreadProcessId(hWnd, pid)
    
    hProcess = OpenProcess(PROCESS_VM_READ, False, pid)
    If hProcess = 0 Then
        ' Wir knnen nicht auf den Prozess zugreifen. Evtl. luft er nicht mehr oder wir haben keine Rechte.
        ' Fensterhandle zurcksetzen und 0 zurckgeben.
        hWnd = 0
        GetSolitaireTime = 0
        Exit Function
    End If
    
    ' Adresse des virtuellen Speichers besorgen (Solitr verwendet DMA)
    Call ReadProcessMemory(hProcess, ByVal &H1007170, addr, 4, 0&)
    
    ' Offset des Punktestands addieren (Ergebnis ist die korrekte Adresse)
    addr = addr + &H34
    
    ' Punktestand aus dem Speicher lesen
    Call ReadProcessMemory(hProcess, ByVal addr, time, 4, 0&)
    
    ' Prozesshandle freigeben.
    Call CloseHandle(hProcess)
    
    ' Die Zeit muss noch durch 4 dividiert werden, da Solitr sie intern
    ' mit 4 multipliziert speichert.
    GetSolitaireTime = time / 4

End Function

' Diese Private Funktion findet das Solitrfenster
Private Sub FindSolitaire()

    ' Mit dieser API suchen wir das Solitrfenster. Wir suchen hier nicht
    ' nach dem Fenstertitel ("Solitr"), sondern nach der Fensterklasse,
    ' damit das Programm auch mit der englischen (und anderen) Versionen
    ' luft.
    hWnd = FindWindow("Solitaire", vbNullString)
    ' Wenn kein Fenster gefunden wurde, ist hWnd = 0.

End Sub
